﻿using System.Data;
using System.Windows.Forms;
using System.Collections.Generic;

using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win.UltraWinEditors;

namespace GridWithComboCheck
{
	public partial class Form1 : Form
	{
		public Form1 ()
		{
			InitializeComponent ();

			DataTable dt = new DataTable ("tblGrid");

			DataColumn dc = new DataColumn ("col0", typeof (object));
			dt.Columns.Add (dc);

			dc = new DataColumn ("col1", typeof (object));
			dt.Columns.Add (dc);

			DataRow row = dt.NewRow ();
			row["col0"] = "One;Two";
			row["col1"] = "Two;Three";
			
			dt.Rows.Add (row);

			grid.DataSource = dt;
		}

        bool flag = false;
		private void grid_InitializeRow (object sender, Infragistics.Win.UltraWinGrid.InitializeRowEventArgs e)
		{
            if (!flag)
            {
                UltraGridRow row = e.Row;
                for (int ind = 0; ind < row.Cells.Count; ind++)
                {
                    List<ValueListItem> vlis = new List<ValueListItem>();
                    vlis.Add(new ValueListItem("One", "One"));
                    vlis.Add(new ValueListItem("Two", "Two"));
                    vlis.Add(new ValueListItem("Three", "Three"));

                    UltraComboEditor combo = new UltraComboEditor();
                    combo.CheckedListSettings.CheckBoxStyle = CheckStyle.CheckBox;
                    combo.CheckedListSettings.EditorValueSource = EditorWithComboValueSource.SelectedItem;
                    combo.CheckedListSettings.ItemCheckArea = ItemCheckArea.Item;
                    combo.DropDownListWidth = -1;
                    combo.Items.AddRange(vlis.ToArray());
                    row.Cells[ind].EditorComponent = combo;
                    System.Console.WriteLine("Fired");
                    flag = true;
                }
            }
		}

		private void grid_CellChange (object sender, CellEventArgs e)
		{
			UltraGridCell	cell	= e.Cell;
			UltraGridRow	row		= cell.Row;

			UltraComboEditor combo = cell.EditorComponentResolved as UltraComboEditor;
			UltraComboEditor otherCombo = null;

			if (combo.Equals (grid.Rows[row.Index].Cells["col0"].EditorComponent))
			{
				otherCombo = (UltraComboEditor)grid.Rows[row.Index].Cells["col1"].EditorComponentResolved as UltraComboEditor;
			}
			else
			{
				otherCombo = (UltraComboEditor)grid.Rows[row.Index].Cells["col0"].EditorComponentResolved as UltraComboEditor;
			}

			int checks		= combo		.CheckedItems.Count;
			int checksOther = otherCombo.CheckedItems.Count;
			List <ValueListItem> vlis = new List<ValueListItem> ();
			for (int ind = 0; ind < 3; ind++)
			{

                if (combo.Items[ind].CheckState == CheckState.Checked)
                {
                    otherCombo.Items[ind].CheckState = CheckState.Unchecked;
                }
			}
		}

        private void ultraButton1_Click(object sender, System.EventArgs e)
        {
            
        }
	}
}